#ifndef CORTEOUI_H
#define CORTEOUI_H

#include <QtXml>
#include <QtGui>
#include <QProgressDialog>

#include "CorteoParamWidget.h"
#include "LayerForm.h"
#include "DetectorForm.h"
#include "CalibrationForm.h"

#include "XYQt/FSGraph.h"
#include "XYQt/PeriodicTable.h"

class CorteoUi : public QMainWindow
{
  Q_OBJECT

private:

  //bool isError;

  CorteoParamWidget * paramUi; // parameter toolbox 
  QProgressDialog   * progress; // progress bar during simulations

  QTabWidget * tab; // tab containing graphs and constituing main window

  FSGraph * mainGraph;
  FSGraph * angleGraph;

  QProcess * corteoProcess;

  QString corteoOutput, corteoError;

  void appendEventsToListmodeFile();

public:
  CorteoUi(QWidget *parent = 0, int maxlayer = 5, int maxelement = 5, QSplashScreen * splash = 0);

  bool writeCorteoIn(int technique);
  bool readIBAOutput();

  bool runCorteo(int technique);
  bool printLog();

  void addAngleData(FSDataSet * angleData);

public slots:

  bool go();
  bool applyCalib();

  void updateProgress();
  void readImplOutput(int exitStatus);
  void readIBAOutput(int exitStatus);
  void readFullRBS(int exitStatus);
  void UpdateConnectCorteoLoadPushbutton();
  bool writeCorteoIn();
  bool readCorteoDetect();
  bool readCorteoDetectFullRBS();
  bool readCorteoOut();

  void endSimulations();

};

#endif // CORTEOUI_H



