
#ifndef ELEMENTFORM_H
#define ELEMENTFORM_H

#include<QtXml>

#include "ui_ElementForm.h"
#include "XYQt/PeriodicTable.h"
#include "XYQt/FSDoubleValidator.h"

class ElementForm : public QWidget, public Ui::ElementForm
{
  Q_OBJECT

private:
  Atom _element;

public slots:
  Atom setElement();

public:

  ElementForm(QWidget * parent);
  virtual ~ElementForm() {};

  bool setFromNode(QDomNode &n);
  QDomElement XMLNode(QDomDocument &doc);

  static Atom selectElement(QWidget * parent);
  static Atom selectElement(QWidget * parent, QPushButton * pb, QComboBox * cb);

  static Atom setElement(QString atomicSymbol, QPushButton* pb, QComboBox *cb, double mass = 0);
  static Atom setElement(Atom a, QPushButton * pb, QComboBox * cb, double mass = 0);
  static Atom setElement(int  Z, QPushButton * pb, QComboBox * cb, double mass = 0);

  Atom setElement(QString atomicSymbol, double mass = 0);
  Atom setElement(int Z, double mass = 0);
  void setElement(Atom a, double mass = 0);

  QString ZMass(int isotope = -1);
  double concentration();
  double compoundCorr();
  QString corteo();
  Atom element() { return _element; }

  bool update(bool isDetection, bool isFullCascade);

  bool isUsed();
  int numberIsotopesToSimulate();

};

#endif // ELEMENTFORM_H
