/* This file is part of the Allegria project
   Copyright (C) 2004 Francois Schiettekatte <francois.schiettekatte@umontreal.ca>

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; see the file COPYING.  If not, write to
   the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.
*/

#ifndef FSEDITAXIS_H
#define FSEDITAXIS_H

#include <qdialog.h>
/*
#include <qpushbutton.h>
#include <qlineedit.h>
#include <qcheckbox.h>
#include <qradiobutton.h>
*/
#include <qpen.h>
#include <qpixmap.h>

#include "ui_FSEditAxis.h"
#include "FSAxis.h"

class FSEditAxis : public QDialog, private Ui::FSEditAxis
{
        Q_OBJECT
    private:
        QFont selectedTitleFont, selectedLabelFont;
        QColor selectedTitleColor, selectedLabelColor;
        QColor selectedFrameColor, selectedTickColor, selectedGridColor;
        QPixmap pm;

        void newColor(QColor * selectedColor, QPushButton * btColor);

    public:
        FSEditAxis(FSAxis *axis, QWidget *parent = 0 );

        QString title( void );
        int titlePos( void );
        QFont titleFont( void );
        QColor titleColor( void );
        int labelPos( void );
        QFont labelFont( void );
        QColor labelColor( void );
        QPen framePen( void );
        int framePos( void );
        QPen tickPen( void );
        int tickPos( void );
        QPen gridPen( void );
        bool drawGrid( void );
        bool isLog( void );
        double min( void );
        double max( void );
        int ntick( void );
        bool extremaChanged( void );

    private slots:
        void newTitleColor( void );
        void newLabelColor( void );
        void newTitleFont( void );
        void newLabelFont( void );

        void newFrameColor( void );
        void newTickColor( void );
        void newGridColor( void );

};

#endif // FSEDITAXIS_H
