/* This file is part of the Allegria project
   Copyright (C) 2004 Francois Schiettekatte <francois.schiettekatte@umontreal.ca>

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; see the file COPYING.  If not, write to
   the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.
*/

#ifndef FSFITDIALOG_H
#define FSFITDIALOG_H

#include <qdialog.h>
#include "ui_FSFitDialog.h"


class FSFitDialog : public QDialog, public Ui::FSFitDialog {
        Q_OBJECT

    private slots:

       void enablePolate( void );
       void disablePolate( void );

    private:
        bool isMarker;

    public:
        FSFitDialog(bool isMarker, QWidget *parent=0 );

        int fitType( void );
        int order( void );
        bool isExtrapolate( void );
        bool isInterpolate( void );

};

#endif // FSFITDIALOG_H

