/*  
    Copyright 2007, Francois Schiettekatte

    This file is part of Corteo.

    Corteo is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Corteo is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Corteo.  If not, see <http://www.gnu.org/licenses/>.

*/

#include "corteoutil.h"
#include "randomx.h"

#include <math.h>
#include <float.h>
#include <stdlib.h> // for correct definition of atof()

// randomly swap 3 times each elements of list so they come out in random order
void randomizelist(float *list, unsigned int maxlist) {
  unsigned int i, ilist, j;
  float x;

  for(i=0; i<maxlist*3; i++) {
    ilist = i%maxlist;
    j = (unsigned int)floor(randomx()*maxlist);
	  x = list[ilist];
    list[ilist] = list[j];
    list[j] = x;
  }
}


// skip to end of line, including end of line character
void ignoreline(FILE *ifp) {
  fscanf(ifp, "%*[^\n]");
  fscanf(ifp, "%*1[\n]");
}

// convert double to float while preventing underflow
float d2f(double val) {
  if(val<0.0) return -val<FLT_MIN?0.0f:(float)val;
  return val<FLT_MIN?0.0f:(float)val;
}

// convert a string to float while preventing underflow
float a2f(char * s) {
  return d2f(atof(s));
}


