
#include "randomx.h"

// making these variable global but static mean that
// they will retaint their value between the function of this file
// so changes by functions of other files does not affect them.
// (...we learn every day!)
static long seed1 = 39419293;
static long seed2 = 93145294;

// random function from P. L'Ecuyer, Communications of the ACM 31 (1988) 742
void randomxinit(long init1, long init2) {
   if(init1) seed1 = init1;
   if(init2) seed2 = init2;
}

long getseed1() { return seed1; }
long getseed2() { return seed2; }

double randomx() {
  int z,k;
  k = seed1 / 53668;
  seed1 = 40014 * (seed1 - k * 53668) - k * 12211;
  if (seed1 < 0) seed1 = seed1 + 2147483563;
  k = seed2 / 52774;
  seed2 = 40692 * (seed2 - k * 52774) - k * 3791;
  if (seed2 < 0) seed2 = seed2 + 2147483399;
  z = seed1 - seed2;
  if (z < 1) z = z + 2147483562;
  return z * 4.65661305956E-10;
}
